# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class BccEmailArchive(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, account_id=None, bcc_email_archive_id=None, created=None, created_by=None, email=None, email_notification_id=None, modified=None, modified_by=None, status=None, uri=None):
        """
        BccEmailArchive - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'account_id': 'str',
            'bcc_email_archive_id': 'str',
            'created': 'str',
            'created_by': 'UserInfo',
            'email': 'str',
            'email_notification_id': 'str',
            'modified': 'str',
            'modified_by': 'UserInfo',
            'status': 'str',
            'uri': 'str'
        }

        self.attribute_map = {
            'account_id': 'accountId',
            'bcc_email_archive_id': 'bccEmailArchiveId',
            'created': 'created',
            'created_by': 'createdBy',
            'email': 'email',
            'email_notification_id': 'emailNotificationId',
            'modified': 'modified',
            'modified_by': 'modifiedBy',
            'status': 'status',
            'uri': 'uri'
        }

        self._account_id = account_id
        self._bcc_email_archive_id = bcc_email_archive_id
        self._created = created
        self._created_by = created_by
        self._email = email
        self._email_notification_id = email_notification_id
        self._modified = modified
        self._modified_by = modified_by
        self._status = status
        self._uri = uri

    @property
    def account_id(self):
        """
        Gets the account_id of this BccEmailArchive.
        The account ID associated with the envelope.

        :return: The account_id of this BccEmailArchive.
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """
        Sets the account_id of this BccEmailArchive.
        The account ID associated with the envelope.

        :param account_id: The account_id of this BccEmailArchive.
        :type: str
        """

        self._account_id = account_id

    @property
    def bcc_email_archive_id(self):
        """
        Gets the bcc_email_archive_id of this BccEmailArchive.
        

        :return: The bcc_email_archive_id of this BccEmailArchive.
        :rtype: str
        """
        return self._bcc_email_archive_id

    @bcc_email_archive_id.setter
    def bcc_email_archive_id(self, bcc_email_archive_id):
        """
        Sets the bcc_email_archive_id of this BccEmailArchive.
        

        :param bcc_email_archive_id: The bcc_email_archive_id of this BccEmailArchive.
        :type: str
        """

        self._bcc_email_archive_id = bcc_email_archive_id

    @property
    def created(self):
        """
        Gets the created of this BccEmailArchive.
        

        :return: The created of this BccEmailArchive.
        :rtype: str
        """
        return self._created

    @created.setter
    def created(self, created):
        """
        Sets the created of this BccEmailArchive.
        

        :param created: The created of this BccEmailArchive.
        :type: str
        """

        self._created = created

    @property
    def created_by(self):
        """
        Gets the created_by of this BccEmailArchive.

        :return: The created_by of this BccEmailArchive.
        :rtype: UserInfo
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """
        Sets the created_by of this BccEmailArchive.

        :param created_by: The created_by of this BccEmailArchive.
        :type: UserInfo
        """

        self._created_by = created_by

    @property
    def email(self):
        """
        Gets the email of this BccEmailArchive.
        

        :return: The email of this BccEmailArchive.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """
        Sets the email of this BccEmailArchive.
        

        :param email: The email of this BccEmailArchive.
        :type: str
        """

        self._email = email

    @property
    def email_notification_id(self):
        """
        Gets the email_notification_id of this BccEmailArchive.
        

        :return: The email_notification_id of this BccEmailArchive.
        :rtype: str
        """
        return self._email_notification_id

    @email_notification_id.setter
    def email_notification_id(self, email_notification_id):
        """
        Sets the email_notification_id of this BccEmailArchive.
        

        :param email_notification_id: The email_notification_id of this BccEmailArchive.
        :type: str
        """

        self._email_notification_id = email_notification_id

    @property
    def modified(self):
        """
        Gets the modified of this BccEmailArchive.
        

        :return: The modified of this BccEmailArchive.
        :rtype: str
        """
        return self._modified

    @modified.setter
    def modified(self, modified):
        """
        Sets the modified of this BccEmailArchive.
        

        :param modified: The modified of this BccEmailArchive.
        :type: str
        """

        self._modified = modified

    @property
    def modified_by(self):
        """
        Gets the modified_by of this BccEmailArchive.

        :return: The modified_by of this BccEmailArchive.
        :rtype: UserInfo
        """
        return self._modified_by

    @modified_by.setter
    def modified_by(self, modified_by):
        """
        Sets the modified_by of this BccEmailArchive.

        :param modified_by: The modified_by of this BccEmailArchive.
        :type: UserInfo
        """

        self._modified_by = modified_by

    @property
    def status(self):
        """
        Gets the status of this BccEmailArchive.
        Indicates the envelope status. Valid values are:  * sent - The envelope is sent to the recipients.  * created - The envelope is saved as a draft and can be modified and sent later.

        :return: The status of this BccEmailArchive.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this BccEmailArchive.
        Indicates the envelope status. Valid values are:  * sent - The envelope is sent to the recipients.  * created - The envelope is saved as a draft and can be modified and sent later.

        :param status: The status of this BccEmailArchive.
        :type: str
        """

        self._status = status

    @property
    def uri(self):
        """
        Gets the uri of this BccEmailArchive.
        

        :return: The uri of this BccEmailArchive.
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """
        Sets the uri of this BccEmailArchive.
        

        :param uri: The uri of this BccEmailArchive.
        :type: str
        """

        self._uri = uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
