# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class BulkSendResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, batch_id=None, envelope_or_template_id=None, error_details=None, errors=None):
        """
        BulkSendResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'batch_id': 'str',
            'envelope_or_template_id': 'str',
            'error_details': 'list[str]',
            'errors': 'list[str]'
        }

        self.attribute_map = {
            'batch_id': 'batchId',
            'envelope_or_template_id': 'envelopeOrTemplateId',
            'error_details': 'errorDetails',
            'errors': 'errors'
        }

        self._batch_id = batch_id
        self._envelope_or_template_id = envelope_or_template_id
        self._error_details = error_details
        self._errors = errors

    @property
    def batch_id(self):
        """
        Gets the batch_id of this BulkSendResponse.
        

        :return: The batch_id of this BulkSendResponse.
        :rtype: str
        """
        return self._batch_id

    @batch_id.setter
    def batch_id(self, batch_id):
        """
        Sets the batch_id of this BulkSendResponse.
        

        :param batch_id: The batch_id of this BulkSendResponse.
        :type: str
        """

        self._batch_id = batch_id

    @property
    def envelope_or_template_id(self):
        """
        Gets the envelope_or_template_id of this BulkSendResponse.
        

        :return: The envelope_or_template_id of this BulkSendResponse.
        :rtype: str
        """
        return self._envelope_or_template_id

    @envelope_or_template_id.setter
    def envelope_or_template_id(self, envelope_or_template_id):
        """
        Sets the envelope_or_template_id of this BulkSendResponse.
        

        :param envelope_or_template_id: The envelope_or_template_id of this BulkSendResponse.
        :type: str
        """

        self._envelope_or_template_id = envelope_or_template_id

    @property
    def error_details(self):
        """
        Gets the error_details of this BulkSendResponse.
        Array or errors.

        :return: The error_details of this BulkSendResponse.
        :rtype: list[str]
        """
        return self._error_details

    @error_details.setter
    def error_details(self, error_details):
        """
        Sets the error_details of this BulkSendResponse.
        Array or errors.

        :param error_details: The error_details of this BulkSendResponse.
        :type: list[str]
        """

        self._error_details = error_details

    @property
    def errors(self):
        """
        Gets the errors of this BulkSendResponse.
        

        :return: The errors of this BulkSendResponse.
        :rtype: list[str]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """
        Sets the errors of this BulkSendResponse.
        

        :param errors: The errors of this BulkSendResponse.
        :type: list[str]
        """

        self._errors = errors

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
