# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class FavoriteTemplatesContentItem(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, error_details=None, favorited_date=None, template_id=None):
        """
        FavoriteTemplatesContentItem - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'error_details': 'ErrorDetails',
            'favorited_date': 'str',
            'template_id': 'str'
        }

        self.attribute_map = {
            'error_details': 'errorDetails',
            'favorited_date': 'favoritedDate',
            'template_id': 'templateId'
        }

        self._error_details = error_details
        self._favorited_date = favorited_date
        self._template_id = template_id

    @property
    def error_details(self):
        """
        Gets the error_details of this FavoriteTemplatesContentItem.

        :return: The error_details of this FavoriteTemplatesContentItem.
        :rtype: ErrorDetails
        """
        return self._error_details

    @error_details.setter
    def error_details(self, error_details):
        """
        Sets the error_details of this FavoriteTemplatesContentItem.

        :param error_details: The error_details of this FavoriteTemplatesContentItem.
        :type: ErrorDetails
        """

        self._error_details = error_details

    @property
    def favorited_date(self):
        """
        Gets the favorited_date of this FavoriteTemplatesContentItem.
        

        :return: The favorited_date of this FavoriteTemplatesContentItem.
        :rtype: str
        """
        return self._favorited_date

    @favorited_date.setter
    def favorited_date(self, favorited_date):
        """
        Sets the favorited_date of this FavoriteTemplatesContentItem.
        

        :param favorited_date: The favorited_date of this FavoriteTemplatesContentItem.
        :type: str
        """

        self._favorited_date = favorited_date

    @property
    def template_id(self):
        """
        Gets the template_id of this FavoriteTemplatesContentItem.
        The unique identifier of the template. If this is not provided, DocuSign will generate a value. 

        :return: The template_id of this FavoriteTemplatesContentItem.
        :rtype: str
        """
        return self._template_id

    @template_id.setter
    def template_id(self, template_id):
        """
        Sets the template_id of this FavoriteTemplatesContentItem.
        The unique identifier of the template. If this is not provided, DocuSign will generate a value. 

        :param template_id: The template_id of this FavoriteTemplatesContentItem.
        :type: str
        """

        self._template_id = template_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
