# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class RecipientSMSAuthentication(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, sender_provided_numbers=None, sender_provided_numbers_metadata=None):
        """
        RecipientSMSAuthentication - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'sender_provided_numbers': 'list[str]',
            'sender_provided_numbers_metadata': 'PropertyMetadata'
        }

        self.attribute_map = {
            'sender_provided_numbers': 'senderProvidedNumbers',
            'sender_provided_numbers_metadata': 'senderProvidedNumbersMetadata'
        }

        self._sender_provided_numbers = sender_provided_numbers
        self._sender_provided_numbers_metadata = sender_provided_numbers_metadata

    @property
    def sender_provided_numbers(self):
        """
        Gets the sender_provided_numbers of this RecipientSMSAuthentication.
        An Array containing a list of phone numbers the recipient may use for SMS text authentication. 

        :return: The sender_provided_numbers of this RecipientSMSAuthentication.
        :rtype: list[str]
        """
        return self._sender_provided_numbers

    @sender_provided_numbers.setter
    def sender_provided_numbers(self, sender_provided_numbers):
        """
        Sets the sender_provided_numbers of this RecipientSMSAuthentication.
        An Array containing a list of phone numbers the recipient may use for SMS text authentication. 

        :param sender_provided_numbers: The sender_provided_numbers of this RecipientSMSAuthentication.
        :type: list[str]
        """

        self._sender_provided_numbers = sender_provided_numbers

    @property
    def sender_provided_numbers_metadata(self):
        """
        Gets the sender_provided_numbers_metadata of this RecipientSMSAuthentication.

        :return: The sender_provided_numbers_metadata of this RecipientSMSAuthentication.
        :rtype: PropertyMetadata
        """
        return self._sender_provided_numbers_metadata

    @sender_provided_numbers_metadata.setter
    def sender_provided_numbers_metadata(self, sender_provided_numbers_metadata):
        """
        Sets the sender_provided_numbers_metadata of this RecipientSMSAuthentication.

        :param sender_provided_numbers_metadata: The sender_provided_numbers_metadata of this RecipientSMSAuthentication.
        :type: PropertyMetadata
        """

        self._sender_provided_numbers_metadata = sender_provided_numbers_metadata

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
